'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _exceptions = require('./exceptions');

var _authentication = require('./authentication');

var _authentication2 = _interopRequireDefault(_authentication);

var _validation = require('./validation');

var _validation2 = _interopRequireDefault(_validation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Configuration = function (_Validation) {
  _inherits(Configuration, _Validation);

  /**
   * @description Auto-hydrate object from configuration
   * @param config
   */
  function Configuration(config) {
    _classCallCheck(this, Configuration);

    var _this = _possibleConstructorReturn(this, (Configuration.__proto__ || Object.getPrototypeOf(Configuration)).call(this));

    _this._hydrate(config, _this._itemsToHydrate());
    return _this;
  }

  _createClass(Configuration, [{
    key: '_hydrate',


    /**
     * @description Hydrate object from configuration settings
     * @param obj
     * @param attributes
     * @private
     */
    value: function _hydrate(obj, attributes) {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = attributes[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var item = _step.value;

          this[item] = obj[item] ? obj[item] : '';
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }

    /**
     * @description Return array with items names to hydrate
     * @returns {[string,string,string,string]}
     * @private
     */

  }, {
    key: '_itemsToHydrate',
    value: function _itemsToHydrate() {
      return ['format', 'credentials', 'url', 'routes'];
    }
  }, {
    key: 'format',
    get: function get() {
      return this._format;
    },
    set: function set(value) {
      if (value !== 'json') throw new _exceptions.ConfigurationWrongFormat();
      this._format = value;
    }
  }, {
    key: 'credentials',
    get: function get() {
      return this._credentials;
    },
    set: function set(value) {
      this._credentials = new _authentication2.default(value);
    }
  }, {
    key: 'url',
    get: function get() {
      return this._url;
    },
    set: function set(value) {
      this._url = value;
    }
  }, {
    key: 'routes',
    get: function get() {
      return this._routes;
    },
    set: function set(value) {
      this._routes = value;
    }

    /**
     * @description Get headers pre formatted
     * @returns {{Authorization: ({header}|*), Accept: string, Content-Type: string}}
     */

  }, {
    key: 'headers',
    get: function get() {
      return {
        'Authorization': this._credentials.getAuthentication(),
        'Accept': 'application/json',
        'Content-Type': 'application/json'
      };
    }
  }]);

  return Configuration;
}(_validation2.default);

exports.default = Configuration;
//# sourceMappingURL=configuration.js.map
