'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _configuration = require('./configuration');

var _configuration2 = _interopRequireDefault(_configuration);

require('isomorphic-fetch');

var _es6Promise = require('es6-promise');

var _es6Promise2 = _interopRequireDefault(_es6Promise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

_es6Promise2.default.polyfill();

var SDK = function (_Configuration) {
  _inherits(SDK, _Configuration);

  function SDK(config) {
    _classCallCheck(this, SDK);

    return _possibleConstructorReturn(this, (SDK.__proto__ || Object.getPrototypeOf(SDK)).call(this, config));
  }

  /**
   * @description Get available timeslots between two dates
   * @param params
   * @return {*|Promise<Promise>|Promise.<TResult>}
   */


  _createClass(SDK, [{
    key: 'getAvailableTimeslots',
    value: function getAvailableTimeslots(params) {
      var _this2 = this;

      var options = {
        method: 'POST',
        headers: this.headers,
        body: JSON.stringify({
          "siteCode": params.siteCode,
          "startDate": params.startDate,
          "endDate": params.endDate
        })
      };

      return this.validateGetAvailableTimeslots(params).then(function () {
        return fetch(_this2.url + _this2.routes.availableTimeslots, options);
      }).then(function (response) {
        return _this2.httpStatus(response);
      }).then(function (response) {
        return _this2.errorCode(response);
      });
    }

    /**
     * @description Create appointment
     * @param params
     * @return {*|Promise<Promise>|Promise.<TResult>}
     */

  }, {
    key: 'createAppointment',
    value: function createAppointment(params) {
      var _this3 = this;

      var options = {
        method: 'POST',
        headers: this.headers,
        body: JSON.stringify({
          "siteCode": params.siteCode,
          "date": params.date,
          "object": params.endDate,
          "category": params.category,
          "description": params.description,
          "timeslotDurationInMinutes": params.timeslotDurationInMinutes,
          "customer": {
            "firstname": params.customer.firstname,
            "lastname": params.customer.lastname,
            "email": params.customer.email,
            "phone": params.customer.phone
          }
        })
      };

      return this.validateCreateAppointment(params).then(function () {
        return fetch(_this3.url + _this3.routes.createAppointment, options);
      }).then(function (response) {
        return _this3.httpStatus(response);
      }).then(function (response) {
        return _this3.errorCode(response);
      });
    }

    /**
     * @description Cancel appointment
     * @param params
     * @return {*|Promise<Promise>|Promise.<TResult>}
     */

  }, {
    key: 'cancelAppointment',
    value: function cancelAppointment(params) {
      var _this4 = this;

      var options = {
        method: 'POST',
        headers: this.headers,
        body: JSON.stringify({
          "siteCode": params.siteCode,
          "bookingId": params.bookingId
        })
      };

      return this.validateCancelAppointment(params).then(function () {
        return fetch(_this4.url + _this4.routes.cancelAppointment, options);
      }).then(function (response) {
        return _this4.httpStatus(response);
      }).then(function (response) {
        return _this4.errorCode(response);
      });
    }
  }]);

  return SDK;
}(_configuration2.default);

exports.default = SDK;
//# sourceMappingURL=sdk.js.map
